package com.plannaplan.responses.mappers;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

import com.plannaplan.entities.Course;
import com.plannaplan.responses.models.CoursesDefaultResponse;
import com.plannaplan.responses.models.CoursesWithGroupsResponse;

public class CoursesResponseMappers {
    public static final List<CoursesDefaultResponse> mapToGetCoursesResponse(List<Course> courses) {
        return courses.stream().filter(Objects::nonNull).map(CoursesDefaultResponse::new).collect(Collectors.toList());
    }

    public static final List<CoursesWithGroupsResponse> mapToGetCoursesWithGroupsResponse(List<Course> courses) {
        return courses.stream().filter(Objects::nonNull).map(CoursesWithGroupsResponse::new)
                .collect(Collectors.toList());
    }
}
